' Programm: spriteraw2acme
' Purpose:  Create data lines for ACME or compatible assembler from raw sprite 
'           datas for usage on Commodore 64
' Platform: Win32, DOS, Linux and everything else where FreeBASIC compiles for
' Licence:  General Public Licence
' Author:   Markus Stehr aka BastetFurry/Di-Treff (bastetfurry@ircnet.de)



' Not the fine art but should work ;)
on error goto fehler
print "Simple raw sprite data to ACME compatible data converter."
print "Copyright 2005 BastetFurry of Dienstagstreff."
print "This programm is licensed under the General Public Licence."
print

' Check if the user read the documentation, if not tell him how to use this thing
if command$ = "" or command$(1) = "-o" and command$(3) = "" or command$ = "-h" then
  print "Usage:"
  print "spriteraw2acme filename [-o output]"
  print 
  print "filename is the raw sprite data to convert to ACME compatible data code"
  print "-o output (optional) will create a file called output with the ACME data code"
  print
  print "Open the resulting file named filename.out or the name you provided with -o"
  print "in your favorite editor and copy_n_paste into your sourcecode."
  end
end if

' Check if the filename exists
if dir$(command$(1),39) = "" then
  print "Bad filename!"
  end
end if

print "Converting "+command$(1)+" to ACME data..."

' Do we use the default output?
if command$(2) = "" then
  open command$(1) for binary as #1
  open command$(1)+".out" for output as #2
end if

' Or do we use a custom output?
if command$(2) = "-o" then
  open command$(1) for binary as #1
  open command$(3) for output as #2
end if  

' Buffer for get
a$ = " "

' This could be done more fancy, but it works.
' Create the output file, we do 3 lines so that it stays readable.
print #2,"!byte ";
for stelle = 1 to 21
  get #1,stelle,a$
  print #2,"$";
  print #2,hex$(asc(a$));
  if stelle < 21 then print #2,",";
next stelle
print #2,""

'Second line
print #2,"!byte ";
for stelle = 22 to 42
  get #1,stelle,a$
  print #2,"$";
  print #2,hex$(asc(a$));
  if stelle < 42 then print #2,",";
next stelle
print #2,""

'Third line
print #2,"!byte ";
for stelle = 43 to 63
  get #1,stelle,a$
  print #2,"$";
  print #2,hex$(asc(a$));
  if stelle < 63 then print #2,",";
next stelle
print #2,""

' We close the files and finish up.
close 1
close 2

print "Done!"
end

' This will get called on any error
fehler:
print "Fatal error occured!"
print "Check your command line."
print "If that dosnt help check your disk space."
print "If all fails contact me!"